/****************************************************************************
** Form implementation generated from reading ui file 'connectionviewer.ui'
**
** Created: Tue Oct 24 19:04:25 2000
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "connectionviewer.h"

#include <qheader.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/* 
 *  Constructs a ConnectionViewerBase which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ConnectionViewerBase::ConnectionViewerBase( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ConnectionViewerBase" );
    resize( 705, 315 ); 
    setCaption( tr( "View Connections"  ) );
    setSizeGripEnabled( TRUE );
    QWhatsThis::add(  this, tr( "<b>View Connections</b><p>Displays all connections in the current form Select a connection from the list and click the <b>Edit</b>-button to change the connection.</p>" ) );
    grid = new QGridLayout( this ); 
    grid->setSpacing( 6 );
    grid->setMargin( 11 );

    hbox = new QHBoxLayout; 
    hbox->setSpacing( 6 );
    hbox->setMargin( 0 );

    helpButton = new QPushButton( this, "helpButton" );
    helpButton->setText( tr( "&Help"  ) );
    helpButton->setAutoDefault( TRUE );
    QWhatsThis::add(  helpButton, tr( "" ) );
    hbox->addWidget( helpButton );
    QSpacerItem* spacer = new QSpacerItem( 0, 0, QSizePolicy::Expanding, QSizePolicy::Minimum );
    hbox->addItem( spacer );

    closeButton = new QPushButton( this, "closeButton" );
    closeButton->setText( tr( "&Close"  ) );
    closeButton->setAutoDefault( TRUE );
    QWhatsThis::add(  closeButton, tr( "Close the Dialog." ) );
    hbox->addWidget( closeButton );

    grid->addMultiCellLayout( hbox, 3, 3, 0, 1 );

    connectionListView = new QListView( this, "connectionListView" );
    connectionListView->addColumn( tr( "Sender" ) );
    connectionListView->addColumn( tr( "Signal" ) );
    connectionListView->addColumn( tr( "Receiver" ) );
    connectionListView->addColumn( tr( "Slot" ) );
    connectionListView->setAllColumnsShowFocus( TRUE );
    connectionListView->setShowSortIndicator( TRUE );
    QWhatsThis::add(  connectionListView, tr( "<b>Displays a list of connections.</b><p>Select a connection and choose edit, or double-click on an item to change the connection.</p>" ) );

    grid->addMultiCellWidget( connectionListView, 0, 2, 0, 0 );

    editButton = new QPushButton( this, "editButton" );
    editButton->setText( tr( "&Edit..."  ) );
    QToolTip::add(  editButton, tr( "Edit connection" ) );
    QWhatsThis::add(  editButton, tr( "Opens a dialog to change the selected connection." ) );

    grid->addWidget( editButton, 0, 1 );
    QSpacerItem* spacer_2 = new QSpacerItem( 0, 0, QSizePolicy::Minimum, QSizePolicy::Expanding );
    grid->addItem( spacer_2, 2, 1 );

    disconnectButton = new QPushButton( this, "disconnectButton" );
    disconnectButton->setText( tr( "&Disconnect"  ) );

    grid->addWidget( disconnectButton, 1, 1 );

    // signals and slots connections
    connect( closeButton, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( editButton, SIGNAL( clicked() ), this, SLOT( editConnection() ) );
    connect( disconnectButton, SIGNAL( clicked() ), this, SLOT( disconnectConnection() ) );
    connect( connectionListView, SIGNAL( currentChanged(QListViewItem*) ), this, SLOT( currentConnectionChanged(QListViewItem*) ) );
    connect( connectionListView, SIGNAL( returnPressed(QListViewItem*) ), this, SLOT( editConnection() ) );
    connect( connectionListView, SIGNAL( selectionChanged(QListViewItem*) ), this, SLOT( currentConnectionChanged(QListViewItem*) ) );
    connect( connectionListView, SIGNAL( doubleClicked(QListViewItem*) ), this, SLOT( editConnection() ) );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
ConnectionViewerBase::~ConnectionViewerBase()
{
    // no need to delete child widgets, Qt does it all for us
}

void ConnectionViewerBase::currentConnectionChanged(QListViewItem*)
{
    qWarning( "ConnectionViewerBase::currentConnectionChanged(QListViewItem*): Not implemented yet!" );
}

void ConnectionViewerBase::disconnectConnection()
{
    qWarning( "ConnectionViewerBase::disconnectConnection(): Not implemented yet!" );
}

void ConnectionViewerBase::editConnection()
{
    qWarning( "ConnectionViewerBase::editConnection(): Not implemented yet!" );
}

